///////////////////////////////////////////////////////////////
//  Serial communication
//
// FILE: comm.h
//
// CREATED:07.09.1999
// (C) Borisov E.S. , Kiev UA
///////////////////////////////////////////////////////////////
#define USECOMM      // COMM API

#ifndef COMM2_H
#define COMM2_H

const BYTE NUMBER_PORTS = 2;

const DWORD INQUEUE = 4096;  // size of input buffer
const DWORD OUTQUEUE = 4096;  // size of output buffer
const DWORD BREAK_INTERVAL = 100;
//////////////////////////////
class CSerialComm
{
public:
	void Flush();
	void SetReadTimeOuts(DWORD dwReadTime);
	CSerialComm();
	CSerialComm( BYTE  bPortA,
	 	 	     DWORD dwBaudRateA = CBR_9600,
				 BYTE  bByteSizeA = 8,
				 BYTE  bParityA = NOPARITY,
				 BYTE  bStopBitsA = TWOSTOPBITS);
			  

	VOID OpenPort();
	VOID ClosePort();

	VOID ClearPort();
	
	BOOL Connected() const;
	
	BOOL SetPortParams();
	
	INT ReadBlock( LPBYTE lpByte, DWORD dwLength );
	INT WriteBlock(  LPBYTE lpByte , DWORD dwBytesToWrite);
	
	VOID SendByte( BYTE bByte);
	BYTE ReceiveByte();
	
	VOID SetDTR();
	VOID DropDTR();

	VOID SendBreak();


	VOID SetPortNumber(BYTE bNumber);
	BYTE GetPortNumber() const ;
	
	VOID SetBaudRate(DWORD dwBaudRateA);
	DWORD GetBaudRate() const;
	
	VOID SetByteSize(BYTE bByteSizeA);
	BYTE GetByteSize() const;
	
	VOID SetStopBits(BYTE bStopBitsA);
	BYTE GetStopBits() const;
	
	VOID SetParity(BYTE bParityA);
	BYTE GetParity() const;
	
	~CSerialComm();
private:
	HANDLE m_hPort;
	BOOL m_fConnect;
	BYTE m_bPort;
	
	DWORD   m_dwBaudRate;
	BYTE   	m_bByteSize;
	BYTE	m_bParity;
	BYTE	m_bStopBits; 

};
#endif