///////////////////////////////////////////////////////////////
//  DNC protocol
//
// FILE: DNCP.cpp
//
// CREATED:01.10.1999
// (C) Borisov E.S. , Kiev UA
///////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "const.h"
#include "funclib.h"
#include "comm.h"
#include "CRT_DNC_Test.h"
#include "DNCP.h"

///////////////////////////////////////////////////////////
// FUNCTION :void DNCP_to()
// PURPOSE:
void DNCP_to()
{
	
	BYTE  bNumberTool = 0; // 
	CHAR  szFileName[10] = "";// 
	CHAR  szFullFileName[255] = "";//   (dir+file)
	
	BYTE bAnswer = 0;
	BOOL lResult = FALSE;
	BYTE bByte = 0;
	DWORD dwRead = 0;
	
	LPSTR lpszFileExt = new CHAR[5]; //    (imp ...)
	LPSTR lpszDirName = new CHAR[255];//   = "d:\\rmail\\upr\\";
	
	DWORD dwDir = sizeof(CHAR)*255;
	DWORD dwExt = sizeof(CHAR)*5;
	HANDLE hFile;
	//////////////////////////////////////////////////////////////////////////////

	//
	//  
	//
	bNumberTool = comm.ReceiveByte()& TOOL_NAME_MASK;  
	//
	//   (5b)
	//
	for(BYTE i= 0 ; i <5 ; i++) 
	{
		szFileName[i] = comm.ReceiveByte(); 
	}

	//
	//   registry  
	//
	if(!GetSendParams( bNumberTool,
		   			   lpszDirName,
  					   dwDir,
 					   lpszFileExt,
					   dwExt))
	{
		printf("unknown tool %d\n",bNumberTool);//  
	
		delete [] lpszFileExt;
		delete [] lpszDirName;

		return;
	}
	sprintf(szFileName,"%s.%s",szFileName,lpszFileExt);
	sprintf(szFullFileName,"%s%s",lpszDirName,szFileName);


	
	printf("program %s to tool %d\n",szFileName,bNumberTool);
	
	////////////////////////////////////
	// prepare to sending CP
	__try
	{
		hFile = CreateFile( szFullFileName,
	  					    GENERIC_READ,
							FILE_SHARE_READ,
							(LPSECURITY_ATTRIBUTES)NULL,
							OPEN_EXISTING,
							FILE_FLAG_WRITE_THROUGH|FILE_FLAG_SEQUENTIAL_SCAN,
							NULL);

								  	
		if(hFile == INVALID_HANDLE_VALUE)
		{
			errorMsg(2,szFullFileName);
			__leave;
		}
		printf("file %s open\n",szFullFileName);
		comm.SendByte(COMM_MSG_READY_TO_SEND);
		
		bAnswer = comm.ReceiveByte();
		
		if(bAnswer!= COMM_MSG_READY_TO_RECEIVE)
		{
			printf("tool not ready to receive 0x%x\n",bAnswer);
			__leave;
		}
		printf("tool ready to receive 0x%x\n",bAnswer);
		
		comm.SetReadTimeOuts(TIMEOUTS_READ_ERROR);
		comm.DropDTR();// DTR
		///////////////////////////////////////////////////////
		// send CP
		for(;;)
		{
			////////////////////////////////////
			//    
			lResult  = ReadFile( hFile,
								(LPVOID)&bByte,
								 1,
								 &dwRead,
								 LPOVERLAPPED(NULL));
			if( !lResult ) 
			{
				errorMsg(2,"ReadFile");
				__leave;
			}
			
			
			if( dwRead == 0 ) //EOF
			{
				
				printf("-=== EOF ===-\n");
				//////////////////////////////////////////
				// EOF processing
				comm.Flush();
				comm.SetReadTimeOuts(TIMEOUTS_READ_NORMAL);//     
				bAnswer = 0;
				bAnswer = comm.ReceiveByte();
				if(bAnswer == COMM_MSG_SUCCESSFYLLY_RECEIVE_END)
				{
					printf("CP successfuly send 0x%x\n",bAnswer);
				}
				else
				{
					printf("CP send with out confirmation 0x%x\n",bAnswer);
				}
				//
				/////////////////////////////////////////
				comm.SendByte(COMM_MSG_INITUMS);
				break;
			}
			//
			///////////////////////////////////////////
			
			/////////////////////////
			//print Byte
			switch (bByte)
			{
				case LF:
				{
					printf("\n<LF>");
					break;
				}
				case CR:
				{
					printf(" <CR>\r");
					break;
				}
				default:
				{
					printf("%c",bByte);
					break;
				}
			}

			//
			///////////////////////////////////////////////////
			
			////////////////////////////////////////////////////
			// receive Answer
			
			bAnswer = 0;
			bAnswer = comm.ReceiveByte();
			if(bAnswer !=0)
			{
				if(bAnswer!= COMM_MSG_SUCCESSFYLLY_RECEIVE_END)
				{
					printf("error sending 0x%x\n",bAnswer);
				    __leave;
				}
			}
			//
			////////////////////////////////////////

			////////////////////////////////////////////////////
			// send Byte
			if(bByte != CR)
			{
				bByte = ASCIItoISO(bByte);
				comm.SendByte(bByte);
			}
			//
			//////////////////////////////////////////////////////
		}
		//
		//////////////////////////////////////////////////////
	}
	//
	/////////////////////////////////////
	__finally
	{
	
		delete [] lpszFileExt;
		delete [] lpszDirName;

		comm.SetReadTimeOuts(TIMEOUTS_READ_NORMAL);
		comm.SetDTR();
		if(hFile!=INVALID_HANDLE_VALUE)
		{
			CloseHandle(hFile);
			hFile = INVALID_HANDLE_VALUE;
		}
	
	}

}

///////////////////////////////////////////////////////////
// FUNCTION :void  DNCP_from()
// PURPOSE:
void  DNCP_from()
{

	BYTE  bNumberTool = 0; // 
	CHAR  szFileName[10] = "";// 
	CHAR  szFullFileName[255] = "";//   (dir+file)
	
	BYTE bAnswer = 0;
	BOOL lResult = FALSE;
	BYTE bByte = 0;
	DWORD dwWrite = 0;
	
	LPSTR lpszFileExt = new CHAR[5]; //    (imp ...)
	LPSTR lpszDirName = new CHAR[255];//   = "d:\\rmail\\upr\\";
	
	DWORD dwDir = sizeof(CHAR)*255;
	DWORD dwExt = sizeof(CHAR)*5;
	HANDLE hFile;
	//////////////////////////////////////////////////////////////////////////////

	//
	//  
	//
	bNumberTool = comm.ReceiveByte()& TOOL_NAME_MASK;  
	//
	//   (5b)
	//
	for(BYTE i= 0 ; i <5 ; i++) 
	{
		szFileName[i] = comm.ReceiveByte(); 
	}

	//
	//   registry  
	//
	if(!GetReceiveParams( bNumberTool,
		   			   lpszDirName,
  					   dwDir,
 					   lpszFileExt,
					   dwExt))
	{
		printf("unknown tool %d\n",bNumberTool);//  
		delete [] lpszFileExt;
		delete [] lpszDirName;

		return;
	}
	sprintf(szFileName,"%s.%s",szFileName,lpszFileExt);
	sprintf(szFullFileName,"%s%s",lpszDirName,szFileName);

	
	printf("program %s from tool %d\n",szFileName,bNumberTool);
	__try
	{
		////////////////////////////////////
		// prepare to receiving CP
	
		hFile = CreateFile( szFullFileName,
	  					    GENERIC_WRITE,
							0,
							(LPSECURITY_ATTRIBUTES)NULL,
							CREATE_ALWAYS,
							FILE_FLAG_SEQUENTIAL_SCAN,
							NULL);

								  	
		if(hFile == INVALID_HANDLE_VALUE)
		{
			errorMsg(2,szFullFileName);
			__leave;
		}
		printf("file %s created\n",szFullFileName);
		comm.SendByte(COMM_MSG_READY_TO_SEND);
		//
		/////////////////////////////////////
		
		//////////////////////////////////////////////////////////////
		//receiving CP
		for(;;)
			{
				if(!comm.ReadBlock(&bByte,sizeof(BYTE)))
				{
					printf("\n-=== received ===-\n");
					break;
				}
				//
				//    
				//
				if(bByte == LF)
				{
					BYTE bCRbuf = CR;
					printf(" <CR>\r");
					lResult =
						WriteFile(hFile,(LPVOID)&bCRbuf,1,&dwWrite,NULL);
					if(!lResult)
					{
						errorMsg(2,"WriteFile");
						__leave;
					}
				}
				bByte  = ISOtoASCII(bByte);
				lResult = 
					WriteFile(hFile,(LPVOID)&bByte,1,&dwWrite,NULL);
				if(!lResult)
				{
					errorMsg(2,"WriteFile");
					__leave;
				}
				/////////////////////////
				//print Byte
				if(bByte ==LF )
				{
					printf("\n<LF> ");
				}
				else
				{
					printf("%c",bByte);
				}
 				//
			    ///////////////////////////////////////////////////

		}
		//
		///////////////////////////////////////////////////////////
			
	
	}
	__finally
	{
	
		delete [] lpszFileExt;
		delete [] lpszDirName;

		comm.SetReadTimeOuts(TIMEOUTS_READ_NORMAL);
		comm.SetDTR();
		if(hFile!=INVALID_HANDLE_VALUE)
		{
			CloseHandle(hFile);
			hFile = INVALID_HANDLE_VALUE;
		}
	
	}

}


/////////////////////////////////////////////////////////////

/*

  ////////////////////////////////////////////////////////////////////////////////
//  FUNCTION: VOID CPortThread::DNC_Protocol(BYTE bMode);
//  PURPOSE:  
VOID CPortThread::DNC_Protocol(BYTE bMode)
{
	CSingleLock sLock(&m_mutex);
	BYTE  bNumberTool = 0; // 
	CHAR  szFileName[10] = "";// 
	CHAR  szFullFileName[255] = "";//   (dir+file)
	//
	//  
	//
	bNumberTool = m_pComm->ReceiveByte()& TOOL_NAME_MASK;  
	//
	//   (5b)
	//
	for(BYTE i= 0 ; i <5 ; i++) 
	{
		szFileName[i] = m_pComm->ReceiveByte(); 
	}
		
	switch(bMode)
	{
		case COMM_MSG_CP_TO_TOOLS:
		{
			LPSTR lpszFileExt = new CHAR[5]; //    (imp ...)
			LPSTR lpszDirName = new CHAR[255] ;//   = "d:\\rmail\\upr\\";
			DWORD dwDir = sizeof(CHAR)*255;
			DWORD dwExt = sizeof(CHAR)*5;
			//
			//   registry  
			//
			if(!GetSendParams( bNumberTool,
							  lpszDirName,
							  dwDir,
							  lpszFileExt,
							  dwExt))
			{
				PrintMsg(m_bPortNumber,IDS_UNKNOWN_TOOL,"",bNumberTool);//  
				break;
			}
			//
			//    
			//
			sprintf(szFileName,"%s.%s",szFileName,lpszFileExt);
			sprintf(szFullFileName,"%s%s",lpszDirName,szFileName);

			PrintMsg(m_bPortNumber,IDS_CP_TO_TOOLS,szFileName,bNumberTool);
			//
			//   ...
			//
			m_hFile = CreateFile( szFullFileName,
								  GENERIC_READ,
								  FILE_SHARE_READ,
								  (LPSECURITY_ATTRIBUTES)NULL,
								  OPEN_EXISTING,
								  FILE_FLAG_WRITE_THROUGH|FILE_FLAG_SEQUENTIAL_SCAN,
								  NULL);

								  	
			if(m_hFile == INVALID_HANDLE_VALUE)
			{
				errorMsg(m_bPortNumber,szFullFileName);
			}
			else
			{
				//
				//   
				//
				sLock.Lock();
				m_pComm->SendByte(COMM_MSG_READY_TO_SEND);
				sLock.Unlock();
				
				if(m_pComm->ReceiveByte() == COMM_MSG_READY_TO_RECEIVE)
				{
					DWORD dwRead = 0;
					BYTE bAnswer = 0;
					BYTE bByte = 0;
					//
					//     = 0 . 
					//
					sLock.Lock();
					m_pComm->SetReadTimeOuts(TIMEOUTS_READ_ERROR);
					//
					// DTR
					//
					m_pComm->DropDTR();
					sLock.Unlock();
					
			
					for(;;)
					{
						//
						//    
						//
						ReadFile( m_hFile,
								  (LPVOID)&bByte,
								  1,
								  &dwRead,
								  LPOVERLAPPED(NULL));
						if( dwRead == 0 ) 
						{
							//
							//   
							//
							sLock.Lock();
							
							m_pComm->Flush();
							//							
							//     
							//
							m_pComm->SetReadTimeOuts(TIMEOUTS_READ_NORMAL);
							
							//Sleep(TIMEOUTS_AFTER_SENDING);//   ""
							//m_pComm->SendByte(LF);
							
							//							
							//       
							//
							bAnswer = m_pComm->ReceiveByte();
							sLock.Unlock();
							
							if(bAnswer == COMM_MSG_SUCCESSFYLLY_RECEIVE_END)
							{
								PrintMsg(m_bPortNumber,IDS_SUCCESS_CP_SEND_END);
							}
							else
							{
								PrintMsg(m_bPortNumber,IDS_CP_SEND_END);
							}
							break;
						}
						//
						//   ...
						//
						bAnswer = 0;
						
						
						if(m_pComm->ReadBlock(&bAnswer,sizeof(BYTE)))
						{
							//
							//    - 
							//
							PrintMsg(m_bPortNumber,IDS_IO_ERROR);
							break;
						}
						//
						//     <CR>
						//
/////////////////////////////////////////////////////////////////////////////////
						itch (bByte)
						{
						case LF:
							{
								printf(" <LF> %c",bByte);
								break;
							}
						case CR:
							{
								printf(" <CR> %c",bByte);
								break;
							}
						default:
							{
								printf("%c",bByte);
								break;
							}
						}
						printf("%c",bByte);
/////////////////////////////////////////////////////////////////////////////////						
						if(bByte != CR ) 
						{	
							bByte = ASCIItoISO(bByte); //  
													   //  ASCII  ISO 
							sLock.Lock();
							m_pComm->SendByte(bByte);  // ...
							sLock.Unlock();
						}
						
					}
				}
				else
				{
					PrintMsg(m_bPortNumber,IDS_IO_ERROR);
				}
				//
				//     
				//
				sLock.Lock();
				m_pComm->SetReadTimeOuts(TIMEOUTS_READ_NORMAL);
				sLock.Unlock();
				CloseHandle(m_hFile);
				m_hFile = INVALID_HANDLE_VALUE;
	
			}
			break;
		}
	case COMM_MSG_CP_FROM_TOOLS:
		{
		BYTE bCRbuf = 0;
			BYTE bByte = 0;
			
			LPSTR lpszFileExt = new CHAR[5]; //    (imp ...)
			LPSTR lpszDirName = new CHAR[255] ;//   = "d:\\rmail\\upr\\";
			DWORD dwDir = sizeof(CHAR)*255;
			DWORD dwExt = sizeof(CHAR)*5;
			//
			//   registry  
			//
			if(!GetReceiveParams( bNumberTool,
			 				      lpszDirName,
							      dwDir,
							      lpszFileExt,
							      dwExt))
			{
				PrintMsg(IDS_UNKNOWN_TOOL,bNumberTool);//  
				break;
			}
			//
			//    
			//
			sprintf(szFileName,"%s.%s",szFileName,lpszFileExt);
			sprintf(szFullFileName,"%s%s",lpszDirName,szFileName);
			
			PrintMsg(m_bPortNumber,IDS_CP_FROM_TOOLS,szFileName,bNumberTool);
			if(!m_CPFile.Open( szFullFileName,
							   CFile::modeCreate | 
							   CFile::modeWrite | 
							   CFile::typeBinary))
			{
				errorMsg(m_bPortNumber,szFullFileName);
				break;
			}
			m_pComm->SendByte(COMM_MSG_READY_TO_SEND);
			
			//
			//   ...
			//
			for(;;)
			{
				//
				//   
				//
				if(!m_pComm->ReadBlock(&bByte,sizeof(BYTE)))
				{
					PrintMsg(m_bPortNumber,IDS_CP_RECEIVE);
					break;
				}
				//
				//    
				//
				if(bByte == LF)
				{
					bCRbuf = CR;
					m_CPFile.Write(&bCRbuf,sizeof(BYTE));
				}
				bByte  = ISOtoASCII(bByte);
				m_CPFile.Write(&bByte,sizeof(BYTE));
			}
			//m_pComm->SendByte(COMM_MSG_SUCCESSFYLLY_RECEIVE_END);
			m_CPFile.Close();
			
			
			break;

		}
	default:
		{
			PrintMsg(m_bPortNumber,IDS_TOOLS_NOT_RESPONDING);
			break;
		}

	}
	sLock.Lock();
	m_pComm->SendBreak();
	m_pComm->SetDTR();
	sLock.Unlock();
	InitUMS();
}


*/